@echo off
cls
SET OLDJAVA_HOME=%JAVA_HOME%
SET OLDPORT=%PORT%
SET OLDNAMINGPORT=%NAMINGPORT%
SET OLDSERVICENAME=%SERVICENAME%
SET OLDSERVICES=%SERVICES%
SET OLDUSERNAME=%USERNAME%
SET OLDPASSWORD=%PASSWORD%
SET OLDJONAS_BIN=%JONAS_BIN%
SET PORT=9000
SET NAMINGPORT=1099
SET SERVICENAME=Enhydra
SET SERVICES=jtm,dbm,security,web
SET USERNAME=admin
SET PASSWORD=enhydra
SET JONAS_BIN=

if not exist build.properties goto run
rem *********************************************
rem *  Init build.properties parameters
rem *********************************************
find "jdk.dir" < build.properties > jdk.dir.txt
for /F "tokens=1,2* delims==" %%i in (jdk.dir.txt) do SET JAVA_HOME=%%j
del jdk.dir.txt>nul
find "port" < build.properties > port.txt
for /F "tokens=1,2* delims==" %%i in (port.txt) do SET PORT=%%j
del port.txt>nul
find "namingport" < build.properties > namingport.txt
for /F "tokens=1,2* delims==" %%i in (namingport.txt) do SET NAMINGPORT=%%j
del namingport.txt>nul
find "servicename" < build.properties > servicename.txt
for /F "tokens=1,2* delims==" %%i in (servicename.txt) do SET SERVICENAME=%%j
del servicename.txt>nul
find "username" < build.properties > username.txt
for /F "tokens=1,2* delims==" %%i in (username.txt) do SET USERNAME=%%j
del username.txt>nul
find "password" < build.properties > password.txt
for /F "tokens=1,2* delims==" %%i in (password.txt) do SET PASSWORD=%%j
del password.txt>nul
find "services" < build.properties > services.txt
for /F "tokens=1,2* delims==" %%i in (services.txt) do SET SERVICES=%%j
del services.txt>nul
find "jonas_bin" < build.properties > jonas_bin.txt
for /F "tokens=1,2* delims==" %%i in (jonas_bin.txt) do SET JONAS_BIN=%%j
del jonas_bin.txt>nul

:run
if %SYSTEMROOT% == "" goto error
if X%1==X goto start
if %1==-jdk.dir goto jdkdir
if %1==-port goto port
if %1==-namingport goto namingport
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-password goto password
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
if %1==-help goto help
goto errorpatameter

:start
if not exist %JAVA_HOME%\lib\tools.jar goto errorjava
if exist build.properties del build.properties
echo jdk.dir=%JAVA_HOME%>build.properties
echo namingport=%NAMINGPORT%>>build.properties
echo port=%PORT%>>build.properties
echo servicename=%SERVICENAME%>>build.properties
echo username=%USERNAME%>>build.properties
echo password=%PASSWORD%>>build.properties
echo services=%SERVICES%>>build.properties
echo jonas_bin=%JONAS_BIN%>>build.properties

set OLDCLASSPATH=%CLASSPATH%
set OLDPATH=%PATH%
set CLASSPATH=lib\build\ant.jar
set CLASSPATH=%CLASSPATH%;lib\xercesImpl.jar
set CLASSPATH=%CLASSPATH%;%JAVA_HOME%\lib\tools.jar

set PATH=%JAVA_HOME%\bin
java org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT%

set PATH=%OLDPATH%
set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=
set OLDPATH=
goto end

:jdkdir
shift
if "X%1"=="X" goto errorjava
SET JAVA_HOME=%1
shift
if "X%1"=="X" goto start
if %1==-port goto port
if %1==-namingport goto namingport
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-password goto password
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:port
shift
if "X%1"=="X" SET PORT=9000
SET PORT=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-password goto password
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:namingport
shift
if "X%1"=="X" SET NAMINGPORT=1099
SET NAMINGPORT=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-port goto port
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-password goto password
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:servicename
shift
if "X%1"=="X" SET SERVICENAME=Enhydra
SET SERVICENAME=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-port goto port
if %1==-username goto username
if %1==-password goto password
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:username
shift
if "X%1"=="X" SET USERNAME=admin
SET USERNAME=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-port goto port
if %1==-servicename goto servicename
if %1==-password goto password
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:password
shift
if "X%1"=="X" SET PASSWORD=enhydra
SET PASSWORD=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-port goto port
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-services goto services
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:services
shift
if "X%1"=="X" goto defaultservices

SET SERVICES=
SET SERVICESTMP=%1
SET SERVICENAMETEMP=

for /F "tokens=1* delims=:" %%i in ("%SERVICESTMP%") do SET SERVICENAMETEMP=%%i
for /F "tokens=1* delims=:" %%i in ("%SERVICESTMP%") do SET SERVICESTMP=%%j
SET SERVICES=%SERVICENAMETEMP%
if "%SERVICESTMP%."=="." goto continueservices
:loop
	for /F "tokens=1* delims=:" %%i in ("%SERVICESTMP%") do SET SERVICENAMETEMP=%%i
	for /F "tokens=1* delims=:" %%i in ("%SERVICESTMP%") do SET SERVICESTMP=%%j
	SET SERVICES=%SERVICES%,%SERVICENAMETEMP%
	if "%SERVICESTMP%."=="." goto continueservices
goto loop
SET SERVICES=%SERVICES%
goto continueservices

:defaultservices
SET SERVICES=jtm,dbm,security,web

:continueservices
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-port goto port
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-password goto password
if %1==-jonas_bin goto jonas_bin
goto errorpatameter

:jonas_bin
shift
if "X%1"=="X" SET JONAS_BIN=
SET JONAS_BIN=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-port goto port
if %1==-servicename goto servicename
if %1==-username goto username
if %1==-password goto password
if %1==-services goto services
goto errorpatameter

:errorpatameter
echo.
echo     Invalid parameter value
echo.
pause
goto end

:error
echo.
echo          Enviroment variable SYSTEMROOT does not exist.
echo.
echo Set variable SYSTEMROOT to system root of your Windows installation ...
echo.
pause
goto end

:errorjava
echo.
echo     Enviroment variable JAVA_HOME mid not be set right.
echo.
echo Set variable JAVA_HOME to java root folder on your system!
echo.
pause
goto end

rem *********************************************************
rem *  Display HELP message
rem *********************************************************
:help
echo.
echo Parameters value for using with configure.bat :
echo.
echo configure       - Make build.properties file with default values
echo.
echo configure -help - Display this screen
echo.
echo configure [-jdk.dir JAVA_HOME] [-port connecting_port] [-namingport naming_port] [-servicename service_name] [-username admin_username] [-password admin_password] [-services enhydra_startup_services]
echo.
echo.
echo Example:
echo.
echo configure -jdk.dir C:\j2sdk1.4.0 -port 9000 -namingport 1099 -servicename Enhydra -username admin -password enhydra -services security,web -jonas_bin C:\jonas4.3.1-tomcat5.0.30.tgz
echo.
goto end

:end
SET JAVA_HOME=%OLDJAVA_HOME%
SET PORT=%OLDPORT%
SET NAMINGPORT=%OLDNAMINGPORT%
SET SERVICENAME=%OLDSERVICENAME%
SET USERNAME=%OLDUSERNAME%
SET PASSWORD=%OLDPASSWORD%
SET SERVICES=%OLDSERVICES%
SET JONAS_BIN=%OLDJONAS_BIN%
SET OLDANT_HOME=
SET OLDJAVA_HOME=
SET OLDPORT=
SET OLDNAMINGPORT=
SET OLDSERVICENAME=
SET OLDUSERNAME=
SET OLDPASSWORD=
SET OLDSERVICES=
SET OLDJONAS_BIN=