@echo off
rem
rem Find the application home.
rem
if "%OS%"=="Windows_NT" goto nt

echo This is not NT, so please edit this script and set ENTRAY_APP_HOME manually
set ENTRAY_APP_HOME=..\..

:nt
rem %~dp0 is name of current script under NT
set ENTRAY_APP_HOME=%~dp0
rem : operator works similar to make : operator
set ENTRAY_APP_HOME=%ENTRAY_APP_HOME:\entray\bin\=%

rem
rem Run the application.
rem At runtime, the current directory will be that of EnTray.exe
rem
:startup
call "%ENTRAY_APP_HOME%\multiserver\enhydra\bin\InstallEnhydra.bat"
call "%ENTRAY_APP_HOME%\entray\bin\entray.exe" -install %ENTRAY_APP_HOME%\entray
echo enhydra entray installed >%ENTRAY_APP_HOME%\entray\conf\entray.installed
call "%ENTRAY_APP_HOME%\entray\bin\entray.bat" start

if not errorlevel 1 goto end

:end
set ENTRAY_APP_HOME=

